
DATA;
   INFILE "soil.dat" END=LAST;
   INPUT X Y;
   IF LAST THEN DO;
      OUTPUT; X=.; END;  OUTPUT;

PROC NLIN  NOHALVE CONVERGEPARM=.0001 MAXITER=100;
   PARMS T1=2 T2=-4 T3=3 T4=-.4 NU=4;

   IF  _ITER_=-1 THEN SIGH=.005;
      ELSE SIGH= _SSE_/42;

   IF  _OBS_ <= 42 THEN DO;
      IF X=0 THEN F=T1;
      ELSE F=T1/(1+EXP(T2+T3*LOG(X)+T4*LOG(X)*LOG(X)));
      Z=LOG(Y); R=LOG(Y)-F;  DEL=(R*R)/SIGH; NU1=NU+1/2;
      W=((2*NU+1)/DEL)*PROBGAM(DEL/2,NU+3/2)/PROBGAM(DEL/2,NU1);
      HH=MAX(10**(-5)*NU1,10**(-5)); NUPH=NU1+HH; NUMH=NU1-HH;
      D=(PROBGAM(DEL/2,NUPH)-PROBGAM(DEL/2,NUMH))/(2*HH);
      V= DIGAMMA(NU1)-LOG(DEL/2)+D/PROBGAM(DEL/2,NU1);
      C+V; END;
   ELSE DO;
     Z=-42/C; NU=Z;  F=NU;  W=1;  END;
 MODEL Z=F;  _WEIGHT_=W;
 OUTPUT PARMS=T1H T2H T3H T4H NUH;
  ID  SIGH W V DEL;
DATA; SET;
   IF  _N_=43 THEN DELETE;

PROC NLIN SIGSQ=1;
   PARMS T1=0 T2=0 T3=0 t4=0 NU=0 SIG=0;

   IF  _ITER_=-1 THEN DO;
     T1=T1H; T2=T2H; T3=T3H; T4=T4H; NU=NUH; SIG=SIGH; END;

   IF X=0 THEN F=T1;
   ELSE F=T1/(1+EXP(T2+T3*LOG(X)+T4*LOG(X)*LOG(X)));
   R=LOG(Y)-F; DEL=(R*R)/SIG;
   Q1=-.5*(W*DEL+LOG(SIG));  Q2=LOG(NU)+NU*V;  Z=Q1+Q2;
   MODEL Z=Q1+Q2;
RUN;
