TITLE 'THE STACK LOSS DATA: T ERRORS';
DATA;
   INFILE "stack.dat" END=LAST;
   INPUT Y AIR TEMP ACID;
   IF LAST THEN DO;
      OUTPUT;
      Y=.;
      END;
   OUTPUT;

PROC NLIN  NOHALVE CONVERGEPARM=.0001 MAXITER=250;
   PARMS  T1=-40 T2=.7 T3=1 T4=-.1 NU=4;

   IF _ITER_=-1 THEN SIGH=8;
      ELSE SIGH=_SSE_/21;

   IF _OBS_ <= 21 THEN DO;
      F=T1+T2*AIR+T3*TEMP+T4*ACID;
      Z=Y;
      R=Z-F;
      DEL=(R*R)/SIGH;
      W=(NU+1)/(NU+DEL);
      C1+(DIGAMMA((NU+1)/2)-LOG((NU+DEL)/2)-W+1)/21;
      DFT1=1;
      DFT2=AIR;
      DFT3=TEMP;
      DFT4=ACID;
      DFNU=0;
      END;
   ELSE DO;
      Z=(-3-SQRT(9-12*C1))/(6*C1);
      NU=Z;
      F=NU;
      W=1;
      DFT1=0;
      DFT2=0;
      DFT3=0;
      DFT4=0;
      DFNU=1;
      END;

   _WEIGHT_=W;
   MODEL Z=F;
   DER.T1=DFT1;
   DER.T2=DFT2;
   DER.T3=DFT3;
   DER.T4=DFT4;
   DER.NU=DFNU;
   OUTPUT  PARMS= T1H T2H T3H T4H NUH;
   ID SIGH W DEL DFT1 DFT2 DFT3 DFT4;

DATA;
   SET;
   IF _N_=22 THEN DELETE;
   V=LOG(2*W/(NUH+1))+DIGAMMA((NUH+1)/2);

PROC NLIN SIGSQ=1;
   PARMS T1=0 T2=0 T3=0 t4=0 NU=0 SIG=0;

   IF _ITER_=-1 THEN DO;
      T1=T1H; T2=T2H; T3=T3H; T4=T4H; NU=NUH; SIG=SIGH; END;

   F=T1+T2*AIR+T3*TEMP+T4*ACID;
   R=Y-F;
   DEL=(R*R)/SIG;
   Q1=-.5*(W*DEL+LOG(SIG));
   Q2=(NU/2)*(LOG(NU/2)+V-W)-LGAMMA(NU/2);
   Z=Q1+Q2;
   MODEL Z=Q1+Q2;
   DER.T1=(W*R/SIG)*DFT1;
   DER.T2=(W*R/SIG)*DFT2;
   DER.T3=(W*R/SIG)*DFT3;
   DER.T4=(W*R/SIG)*DFT4;
   DER.SIG=(W*DEL-1)/(2*SIG);
   DER.NU=.5*(LOG(NU/2)-DIGAMMA(NU/2)+V-W+1);
RUN;
